Imports iNTERFACEWARE.Chameleon
' This application is a simple example of using the Chameleon generated objects in a 'Client'
' configuration.  It is intended to be a helpful starting point in understanding how to use these objects
' but must be fleshed out in the following areas to provide a full solution for an
' application HL7 interface:
' 1) You will need to work out how your application will handle logging of messages
'    and data, in particular how bad transactions should be logged.
' 2) The code will need to be modified to insert the parsed data into a database whether
'    by using explicit database calls or by going through some type of middle tier layer that
'    your application may support.
' 3) Some customers choose to deploy HL7 interfaces as Windows Services.  This can be done
'    easily with Chameleon.  One thing to keep in mind though is that the networking components
'    supplied with Chameleon require a Windows 'message loop'.  Often times Windows Services do
'    not have a message loop - but one can be easily set up by invoking RunMessageLoop on
'    the networking component supplied with Chameleon.  See the manual for running Chameleon
'    within services.
' 4) Definitely take the time to read the manual and go through the tutorials after looking
'    at this example before attempting to deploy a production solution.  We do provide custom
'    onsite training and technical implementation services if you require them.
'
' If you are looking for a much more complete 'out of the box' solution for your HL7 needs it would be
' a good idea to evaluate Iguana - Iguana is powered by Chameleon but
' provides a complete runtime web based infrastructure for your HL7 interfaces.
' So it provides advanced logging and monitoring capability for you
' which makes it a very attractive option for many customers.

' According to MSDN, the limit for the text box size is 32K
Public Class ClientForm
    Inherits System.Windows.Forms.Form
    Implements Log
    Dim Engine As New ClientEngine
    Dim messageGeneratorVector As New ArrayList
    Dim CR, LF, CRLF As String
    Dim FlatWire As String
    Const MAX_MESSAGE_SIZE As Long = 200
    Const MAX_TEXT_SIZE As Long = 30000
    Const MESSAGE_DEFINITION_FILE As String = "..\test.vmd"


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents LlpClient As iNTERFACEWARE.Chameleon.LlpClient
    Friend WithEvents lblConfiguration As System.Windows.Forms.Label
    Friend WithEvents cbConfiguration As System.Windows.Forms.ComboBox
    Friend WithEvents btnConnectDisconnect As System.Windows.Forms.Button
    Friend WithEvents txtHost As System.Windows.Forms.TextBox
    Friend WithEvents lblHost As System.Windows.Forms.Label
    Friend WithEvents btnSendMessage As System.Windows.Forms.Button
    Friend WithEvents cbMessage As System.Windows.Forms.ComboBox
    Friend WithEvents lblPort As System.Windows.Forms.Label
    Friend WithEvents txtPort As System.Windows.Forms.TextBox
    Friend WithEvents txtMain As System.Windows.Forms.TextBox
    Friend WithEvents cbMessage2 As System.Windows.Forms.ComboBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnConnectDisconnect = New System.Windows.Forms.Button
        Me.btnSendMessage = New System.Windows.Forms.Button
        Me.txtPort = New System.Windows.Forms.TextBox
        Me.lblPort = New System.Windows.Forms.Label
        Me.txtHost = New System.Windows.Forms.TextBox
        Me.lblHost = New System.Windows.Forms.Label
        Me.LlpClient = New iNTERFACEWARE.Chameleon.LlpClient
        Me.lblConfiguration = New System.Windows.Forms.Label
        Me.cbConfiguration = New System.Windows.Forms.ComboBox
        Me.txtMain = New System.Windows.Forms.TextBox
        Me.cbMessage = New System.Windows.Forms.ComboBox
        Me.SuspendLayout()
        '
        'btnConnectDisconnect
        '
        Me.btnConnectDisconnect.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.btnConnectDisconnect.Location = New System.Drawing.Point(172, 340)
        Me.btnConnectDisconnect.Name = "btnConnectDisconnect"
        Me.btnConnectDisconnect.Size = New System.Drawing.Size(120, 24)
        Me.btnConnectDisconnect.TabIndex = 8
        Me.btnConnectDisconnect.Text = "&Connect"
        '
        'btnSendMessage
        '
        Me.btnSendMessage.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.btnSendMessage.Enabled = False
        Me.btnSendMessage.Location = New System.Drawing.Point(12, 340)
        Me.btnSendMessage.Name = "btnSendMessage"
        Me.btnSendMessage.Size = New System.Drawing.Size(120, 24)
        Me.btnSendMessage.TabIndex = 7
        Me.btnSendMessage.Text = "&Send Message"
        '
        'txtPort
        '
        Me.txtPort.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtPort.Location = New System.Drawing.Point(395, 308)
        Me.txtPort.Name = "txtPort"
        Me.txtPort.Size = New System.Drawing.Size(125, 20)
        Me.txtPort.TabIndex = 4
        Me.txtPort.Text = "5123"
        '
        'lblPort
        '
        Me.lblPort.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lblPort.Location = New System.Drawing.Point(350, 308)
        Me.lblPort.Name = "lblPort"
        Me.lblPort.Size = New System.Drawing.Size(35, 24)
        Me.lblPort.TabIndex = 3
        Me.lblPort.Text = "Port:"
        Me.lblPort.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtHost
        '
        Me.txtHost.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtHost.Location = New System.Drawing.Point(395, 343)
        Me.txtHost.Name = "txtHost"
        Me.txtHost.Size = New System.Drawing.Size(125, 20)
        Me.txtHost.TabIndex = 6
        Me.txtHost.Text = "localhost"
        '
        'lblHost
        '
        Me.lblHost.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lblHost.Location = New System.Drawing.Point(350, 343)
        Me.lblHost.Name = "lblHost"
        Me.lblHost.Size = New System.Drawing.Size(35, 24)
        Me.lblHost.TabIndex = 5
        Me.lblHost.Text = "Host:"
        Me.lblHost.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'LlpClient
        '
        Me.LlpClient.HeaderBlock = ""
        Me.LlpClient.TrailerBlock = "" & Microsoft.VisualBasic.ChrW(13)
        '
        'lblConfiguration
        '
        Me.lblConfiguration.Location = New System.Drawing.Point(35, 12)
        Me.lblConfiguration.Size = New System.Drawing.Size(125, 24)
        Me.lblConfiguration.Name = "lblConfiguration"
        Me.lblConfiguration.TabIndex = 0
        Me.lblConfiguration.Text = "Configuration:"
        Me.lblConfiguration.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'cbConfiguration
        '
        Me.cbConfiguration.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cbConfiguration.Location = New System.Drawing.Point(165, 12)
        Me.cbConfiguration.Name = "cbConfiguration"
        Me.cbConfiguration.Size = New System.Drawing.Size(330, 21)
        Me.cbConfiguration.TabIndex = 1
        '
        'txtMain
        '
        Me.txtMain.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtMain.BackColor = System.Drawing.SystemColors.HighlightText
        Me.txtMain.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtMain.Location = New System.Drawing.Point(0, 45)        
        Me.txtMain.Multiline = True
        Me.txtMain.Name = "txtMain"
        Me.txtMain.ReadOnly = True
        Me.txtMain.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtMain.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtMain.Size = New System.Drawing.Size(542, 253)
        Me.txtMain.TabIndex = 2
        Me.txtMain.TabStop = false
        Me.txtMain.WordWrap = false
        Me.txtMain.Text = ""
        '
        'cbMessage
        '
        Me.cbMessage.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.cbMessage.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cbMessage.Location = New System.Drawing.Point(12, 310)
        Me.cbMessage.Name = "cbMessage"
        Me.cbMessage.Size = New System.Drawing.Size(280, 21)
        Me.cbMessage.TabIndex = 9
        '
        'ClientForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(542, 369)
        Me.Controls.Add(Me.cbMessage)
        Me.Controls.Add(Me.cbConfiguration)
        Me.Controls.Add(Me.lblConfiguration)
        Me.Controls.Add(Me.lblHost)
        Me.Controls.Add(Me.txtHost)
        Me.Controls.Add(Me.lblPort)
        Me.Controls.Add(Me.txtPort)
        Me.Controls.Add(Me.btnSendMessage)
        Me.Controls.Add(Me.txtMain)
        Me.Controls.Add(Me.btnConnectDisconnect)
        Me.Name = "ClientForm"
        Me.Text = "Client"
        Me.ResumeLayout(False)

    End Sub

#End Region

    <STAThread()> _
    Shared Sub Main()
        Try
            Dim FormMain As New ClientForm()
            Application.Run(FormMain)
        Catch ex As Exception
            MessageBox.Show(ex.ToString(), "Client", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub ClientForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Define line feed characters
        CR = Chr(13)
        LF = Chr(10)
        CRLF = CR & LF

        ' In order to make the engine useable we must load the vmd file.  This file
        ' contains the information about the structure of the messages, tables, and data
        ' mappings that were defined in the Chameleon GUI.  hl7Engine is a generated 
        ' Engine which has an interface based on the messages and tables defined in the vmd file.
        ' 
        ' Also keep in mind that this example is using the static stubcode 
        ' interface of Chameleon. For advanced applications it is possible to 
        ' use a dynamic interface to populate messages.  See the manual for 
        ' more details.
        Try
            Engine.Load(MESSAGE_DEFINITION_FILE) 'Load the VMD file
            DisplayOutput("Loaded " + MESSAGE_DEFINITION_FILE + CRLF)
            Engine.AddLog(Me)
        Catch ex As iNTERFACEWARE.Chameleon.ChameleonException
            HandleError(ex.ToString())
        End Try

        ' Setting up the combo boxes is just part of mechanics of this example which
        ' is for teaching purposes only.  A real HL7 client would most likely be part
        ' of a backend service.
	' Beginning of message generator block (comment used as an anchor for STVB)
        messageGeneratorVector.Add(New GeneratePatientRegister())
        messageGeneratorVector.Add(New GenerateDefault())
	' End of message generator block (comment used as an anchor for STVB)
        Dim messageIndex As Integer = 0
        For messageIndex = 0 To (messageGeneratorVector.Count() - 1)
            cbMessage.Items.Add(DirectCast(messageGeneratorVector(messageIndex), GenerateMessage).Description())
        Next messageIndex

        cbMessage.SelectedIndex = 0

        Dim configList As New ArrayList
        Dim configIndex As Long
        For configIndex = 0 To (Engine.CountOfConfig - 1)
            configList.Add(Engine.ConfigName(configIndex))
        Next configIndex
        cbConfiguration.DataSource = configList
        cbConfiguration.SelectedIndex = Engine.CurrentConfigIndex
        DisplayOutput("Current Configuration is: " + Engine.ConfigName(cbConfiguration.SelectedIndex) + CRLF)
    End Sub

    ' This code is just part of the mechanics of this example.
    Private Sub cbConfiguration_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbConfiguration.SelectionChangeCommitted
        DisplayOutput("Set Current Configuration to: " + cbConfiguration.Text + CRLF)
        Engine.CurrentConfigIndex = cbConfiguration.SelectedIndex
    End Sub

    ' This code is just part of the mechanics of this example.
    Private Sub btnConnectDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnectDisconnect.Click
        If LlpClient.IsConnected Then
            Try
                LlpClient.Disconnect()
                DisplayOutput("Disconnected from host" + CRLF)
            Catch ex As iNTERFACEWARE.Chameleon.ChameleonException
                DisplayOutput("Error while disconnecting from host: ")
                HandleError(ex.ToString)
            End Try
        Else
            Try
                LlpClient.Connect(txtHost.Text, Val(txtPort.Text))
            Catch ex As iNTERFACEWARE.Chameleon.ChameleonException
                DisplayOutput("Error while connecting to host: ")
                HandleError(ex.ToString)
            End Try

        End If
    End Sub

    ' For demonstration purposes, all runtime errors will be displayed in the output text box
    Private Sub HandleError(ByVal ErrorText As String)
        DisplayOutput(ErrorText)
    End Sub

    ' This code is only for demonstration purposes.  Memo controls can only take a certain amount
    ' of data - 32k at the time this example was written.  As a result we check the length of
    ' the memo control and truncate it if it reaches this limit.
    '
    ' A real HL7 interface should have some type of system of logging into log files.  Iguana for
    ' instance has a very nice logging system that allows administrators to drill into and browse
    ' processed messages and errors.  How you implement this logging is up to your requirements
    ' for run time management of your HL7 interface.
    Public Sub DisplayOutput(ByVal Output As String)
        If Len(txtMain.Text) > MAX_TEXT_SIZE Then
            txtMain.Text = txtMain.Text.Substring(txtMain.TextLength / 2, txtMain.TextLength - txtMain.TextLength / 2)
        End If
        txtMain.AppendText(Output + CRLF)
    End Sub

    ' Messages may be sent only when the client is connected
    Private Sub btnSendMessage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendMessage.Click
    Try
            FlatWire = DirectCast(messageGeneratorVector(cbMessage.SelectedIndex), GenerateMessage).GenerateMessage(Engine)

    Catch ex As iNTERFACEWARE.Chameleon.ChameleonException
        DisplayOutput("Error while generating message: ")
        HandleError(ex.ToString)
        Exit Sub
    End Try

        DisplayOutput("Sending Message:")
        DisplayOutput(Engine.MakeMessagePrintable(FlatWire))
        LlpClient.SendMessage(FlatWire)
    End Sub

    ' The Connected event is very important.  One common mistake
    ' that developers often make that are new to socket programming
    ' is to try and invoke the Connect method and then immediately
    ' send data via the socket.  This is not possible to do until the
    ' socket is actually connected.
    Private Sub LlpClient_Connected(ByVal sender As Object, ByVal Args As System.EventArgs) Handles LlpClient.Connected
        btnConnectDisconnect.Text = "&Disconnect"
        txtHost.Enabled = False
        txtPort.Enabled = False
        btnSendMessage.Enabled = True
        DisplayOutput("Client Connected to " + txtHost.Text + " on " + txtPort.Text + CRLF)
    End Sub

    ' This event is fired when we receive a TCP/IP error on the
    ' connection.  This will always terminate the connection so your
    ' real application will need logic to handle this event in determining
    ' if and when it should attempt to re-connect to the other host.
    '
    ' One of the advantages of using Iguana instead of Chameleon is that
    ' Iguana will handle this for you.
    Private Sub LlpClient_ErrorReceived(ByVal sender As Object, ByVal Args As System.EventArgs, ByVal Description As String, ByVal ErrorCode As Integer) Handles LlpClient.ErrorReceived
        btnConnectDisconnect.Text = "&Connect"
        txtHost.Enabled = True
        txtPort.Enabled = True
        btnSendMessage.Enabled = False
        DisplayOutput("Client Error Received: " + CRLF)
        HandleError(Description)
    End Sub

    ' This event is generated when data which is not within the LLP header and trailer
    ' characters is received.  This should be a very rare event and usually indicates
    ' a problem with the implementation of the peer host that is sending HL7 back to your
    ' client.
    Private Sub LlpClient_DataIgnored(ByVal sender As Object, ByVal Args As System.EventArgs, ByVal Data As String) Handles LlpClient.DataIgnored
        DisplayOutput("Ignored data outside of LLP connection:")
        DisplayOutput(Engine.MakeMessagePrintable(Data))
    End Sub

    ' This event is triggered when the llpClient socket receives
    ' an LLP wrapped HL7 message.  The envelope header and trailer
    ' characters will have been stripped off the Message
    ' before being passed to your application in this event.
    '
    ' Most of the time the message received is an ACK message.  However
    ' if you are implementing a lab query interface it might be a lab result
    ' message.  For this example we are assuming it is an ACK message and
    ' just printing it to the memo control.
    Private Sub LlpClient_MessageReceived(ByVal sender As Object, ByVal Args As System.EventArgs, ByVal Message As String) Handles LlpClient.MessageReceived
        DisplayOutput("Received response:")
        ' We use the MakeMessagePrintable function to 'pretty print'
        ' the HL7 message into a format that can be easily read in
        ' the log files.  This function converts \r characters into the
        ' string given in the second argument of MakeMessagePrintable.
        '    i.e. in this case a \r\n sequence which displays nicely in the memo control.
        ' The third argument is the maximum length of the message before
        ' we truncate it.  This is done because displaying data within a memo
        ' control is actually very slow - so displaying a message of 100k in
        ' the memo control window can give the appearance of hanging the server.
        ' (i.e. a long blocking event)
        DisplayOutput(LlpClient.MakeMessagePrintable(Message, CRLF, MAX_MESSAGE_SIZE) + CRLF)

    End Sub

    ' This event is fired when a TCP/IP disconnection completes.
    Private Sub LlpClient_Closed(ByVal sender As Object, ByVal Args As System.EventArgs) Handles LlpClient.Closed
        btnConnectDisconnect.Text = "&Connect"
        DisplayOutput("Client disconnected from server" + CRLF)
        btnSendMessage.Enabled = False
        txtHost.Enabled = True
        txtPort.Enabled = True
    End Sub

    Sub Println(ByVal line As String) Implements Log.Println
        DisplayOutput(line)
    End Sub

End Class

